import { Column, Entity, PrimaryColumn } from "../../../../../../src"

@Entity()
export class Post {
    @PrimaryColumn()
    id: number

    @Column()
    name: string

    // -------------------------------------------------------------------------
    // Integer Types
    // -------------------------------------------------------------------------

    @Column("int64")
    int64: number

    // -------------------------------------------------------------------------
    // Character Types
    // -------------------------------------------------------------------------

    @Column("string")
    string: string

    // -------------------------------------------------------------------------
    // Float Types
    // -------------------------------------------------------------------------

    @Column("float64")
    float64: number

    // -------------------------------------------------------------------------
    // Binary Types
    // -------------------------------------------------------------------------

    @Column("bytes")
    bytes: Buffer

    // -------------------------------------------------------------------------
    // Numeric Types
    // -------------------------------------------------------------------------

    @Column("numeric")
    numeric: string

    // -------------------------------------------------------------------------
    // Date Types
    // -------------------------------------------------------------------------

    @Column("date")
    date: string

    @Column("timestamp")
    timestamp: Date

    // -------------------------------------------------------------------------
    // Other Types
    // -------------------------------------------------------------------------

    @Column("bool")
    bool: boolean

    @Column("json")
    json: Object

    @Column("string", { array: true })
    array: string[]
}
